
#define _GNU_SOURCE 1

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <assert.h>
#include <dlfcn.h>
#include <pthread.h>

// Linux-ised version of GetNativeStackBaseImpl() from jsnativestack.cpp
void *
GetNativeStackBaseImpl(void)
{
    pthread_t thread = pthread_self();

    pthread_attr_t sattr;
    pthread_attr_init(&sattr);
    /*
     * FIXME: this function is non-portable;
     * other POSIX systems may have different np alternatives
     */
    pthread_getattr_np(thread, &sattr);

    void *stackBase = 0;
    size_t stackSize = 0;
    int rc = 
        pthread_attr_getstack(&sattr, &stackBase, &stackSize);
    assert(!rc);
    assert(stackBase);
    pthread_attr_destroy(&sattr);

    return (char*)stackBase + stackSize;
}


void rec ( int level )
{
  int i;
  volatile char lard[100];
  for (i = 0; i < 100; i++) {
    lard[i] = (i + level) % 100;
  }

  if (level > 0) rec(level-1);

  void* hdl = dlopen("./try1so.so", RTLD_LAZY);
  assert(hdl);

}

int main ( void )
{
  char buf[100];
  sprintf(buf, "cat /proc/%d/maps | tail -5", getpid());

  printf("\n");
  system(buf);
  printf("GetNativeStackBase returns %p\n", GetNativeStackBaseImpl());

  printf("\n");
  rec(0);

  system(buf);
  printf("GetNativeStackBase returns %p\n", GetNativeStackBaseImpl());
  printf("\n");

  return 0;
}
